import { SqlExpression } from '@druid-toolkit/query';
import { PlywoodValue } from '../datatypes';
import { SQLDialect } from '../dialect/baseDialect';
import { ChainableExpression, ExpressionJS, ExpressionValue } from './baseExpression';
export declare class SqlAggregateExpression extends ChainableExpression {
    static op: string;
    static KNOWN_AGGREGATIONS: string[];
    static registerKnownAggregation(aggregation: string): void;
    static substituteFilter(sqlExpression: SqlExpression, condition: SqlExpression): SqlExpression;
    static fromJS(parameters: ExpressionJS): SqlAggregateExpression;
    sql: string;
    parsedSql: SqlExpression;
    constructor(parameters: ExpressionValue);
    valueOf(): ExpressionValue;
    toJS(): ExpressionJS;
    equals(other: SqlAggregateExpression | undefined): boolean;
    protected _toStringParameters(_indent?: int): string[];
    protected _calcChainableHelper(_operandValue: any): PlywoodValue;
    protected _getSQLChainableHelper(dialect: SQLDialect, operandSQL: string): string;
}
//# sourceMappingURL=sqlAggregateExpression.d.ts.map